%% ESERCIZIO 2
clear; close all; clc

%% dati del problema
M = 10;   % Massa del carrello [kg]
m = 1;    % massa all'estremo dell'asta [kg]
L = 1;    % lunghezza dell'asta [m]
g = 9.81; % accelerazione di gravit [m/s^2]

%% equazioni del sistema in forma matriciale
A = [0 1 0 0;
     0 0 -m/M*g 0;
     0 0 0 1;
     0 0 g/L*(m+M)/M 0];

B = [0 0;
     1/M -1/(L*M);
     0 0;
     -1/(L*M) 1/(L^2)*(M+m)/(m*M)];

C = [1 0 0 0;
     0 0 1 0];

D = [0 0;
     0 0];

%% stabilit del sistema
autovalori = eig(A); % il sistema  instabile
disp(autovalori)

%% raggiungibilit e osservabilit, coppia - posizione angolare
b=B(:,2);
c=C(2,:);

disp('Raggiungibilit coppia')
R = ctrb(A,b);
det(R)
% il sistema NON  completamente raggiungibile

disp('Osservabilit posizione angolare')
O = obsv(A,c);
det(O)
% il sistema NON  completamente osservabile

%% raggiungibilit e osservabilit, forza - posizione
b=B(:,1);
c=C(1,:);

disp('Raggiungibilit forza')
R = ctrb(A,b);
det(R)
% il sistema  completamente raggiungibile

disp('Osservabilit posizione')
O = obsv(A,c);
det(O)
% il sistema  completamente osservabile

%% ridefinisco d
d = D(1, 1);

%% Progetto della legge di controllo
% ricavo le radici del polinomio
disp('Autovalori desiderati')
autov_controllore = [roots([1 1.5 1]); roots([1 2 1])]; disp(autov_controllore)

disp('Legge di controllo k')
k = acker(A, -b, autov_controllore); disp(k)

disp('Verifica autovalori')
disp(eig(A + b*k))

%% Progetto del ricostruttore dello stato
% ricavo le radici del polinomio
disp('Autovalori desiderati')
autov_ricostruttore = [roots([1 15 100]); roots([1 20 100])]; disp(autov_ricostruttore)

disp('Ricostruttore dello stato k')
lT = acker(A', -c', autov_ricostruttore);
l = lT'; disp(l)

disp('Verifica autovalori')
disp(eig(A + l*c))

%% ---------- SISTEMA LINEARIZZATO REGOLATO  ---------- 
%% STATO INIZIALE VICINO ALL'EQUILIBRIO
AREG=[A+b*k          l*c
      zeros(4,4)    A+l*c];
bREG=[b
    zeros(4,1)];

cREG=[0 0 1 0 0 0 -1 0]; % l'uscita  x3=xhat3-e3: posizione angolare dell'asta
dREG=0;
sistemaREG=ss(AREG,bREG,cREG,dREG);

x0 = [0 0 pi/6 0]';
e0 = [0.01 -0.02 -0.01 0.02]';
xhat0=x0+e0;

T=[0:0.01:20];
v=zeros(size(T));
[YREG,T,XREG]=lsim(sistemaREG,v,T,[xhat0;e0]);
figure(1); plot(T,YREG); hold on;
xlabel('tempo'); ylabel('posizione asta'); title('regolazione posizione asta - linearizzato');
grid;
pause;

%% STATO INIZIALE LONTANO DALL'EQUILIBRIO
x0 = [0 0 pi/3 0]';
e0 = [0.01 -0.02 -0.01 0.02]';
xhat0=x0+e0;
[YREG,T,XREG]=lsim(sistemaREG,v,T,[xhat0;e0]);
figure(2); plot(T,YREG); hold on;
xlabel('tempo'); ylabel('posizione asta'); title('regolazione posizione asta - linearizzato');
grid;
pause;

%% ---------- SISTEMA NON LINEARE REGOLATO  ---------- 
%% STATO INIZIALE VICINO ALL'EQUILIBRIO

Tfin=20;
x0 = [0 0 pi/6 0]';
e0 = [0.01 -0.02 -0.01 0.02]';
% x0 = [0 0 pi/6 0]';
% e0 = [0 0 0 0]';
xhat0=x0+e0;
xin=[xhat0;x0];
opt=odeset('RelTol',1E-8,'AbsTol',1E-8);
[tempoNL,xNL] = ode45('ese_pendolo_carrello_modello',[0 Tfin],xin,opt);
figure(1); plot(tempoNL,xNL(:,7),'r');
xlabel('tempo'); ylabel('posizione asta'); title('regolazione posizione asta - lineare (blu)  NON lineare (rosso');
pause;

%% STATO INIZIALE LONTANO DALL'EQUILIBRIO
Tfin=1.5;
x0 = [0 0 pi/3 0]';
e0 = [0.01 -0.02 -0.01 0.02]';
xhat0=x0+e0;
xin=[xhat0;x0];
% opt=odeset('RelTol',1E-6,'AbsTol',1E-6);
warning('off');
[tempoNL,xNL] = ode45('ese_pendolo_carrello_modello',[0 Tfin],xin);
figure(2); plot(tempoNL,xNL(:,7),'r');
xlabel('tempo'); ylabel('posizione asta'); title('regolazione posizione asta - lineare (blu)  NON lineare (rosso');

